routes/web.php
<?php

use Illuminate\Support\Facades\Auth;
use Illuminate\Support\Facades\Route;

Auth::routes();

Route::get('/', [App\Http\Controllers\HomeController::class, 'index']);
Route::get('/home', [App\Http\Controllers\HomeController::class, 'index'])->name('home');

Route::prefix('admin')->name('admin.')->middleware(['role:admin'])->group(function () {
    Route::resources([
        'users' => \App\Http\Controllers\Admin\UserController::class,
    ]);

    Route::get('/', function () {
        return view('admin.dashboard');
    })->name('dashboard');
});

app/Models/User.php
<?php

namespace App\Models;

// use Illuminate\Contracts\Auth\MustVerifyEmail;
use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Relations\BelongsToMany;
use Illuminate\Database\Eloquent\Builder;
use Illuminate\Foundation\Auth\User as Authenticatable;
use Illuminate\Notifications\Notifiable;
use Illuminate\Support\Facades\Session;
use Laravel\Sanctum\HasApiTokens;
use Laravel\Scout\Searchable;
use Psr\Container\ContainerExceptionInterface;
use Psr\Container\NotFoundExceptionInterface;

class User extends Authenticatable
{
    use HasApiTokens, HasFactory, Notifiable;

    protected $table = 'users';

    /**
     * The attributes that are mass assignable.
     *
     * @var array<int, string>
     */
    protected $fillable = [
        'name',
        'email',
        'password',
    ];

    /**
     * The attributes that should be hidden for serialization.
     *
     * @var array<int, string>
     */
    protected $hidden = [
        'password',
        'remember_token',
    ];

    /**
     * The attributes that should be cast.
     *
     * @var array<string, string>
     */
    protected $casts = [
        'email_verified_at' => 'datetime',
    ];

//    /**
//     * Get the indexable data array for the model.
//     *
//     * @return array
//     */
//    public function toSearchableArray(): array
//    {
//        return $this->toArray();
//    }

    /**
     * @return BelongsToMany
     */
    public function roles(): BelongsToMany
    {
        return $this->belongsToMany(Role::class, 'users_roles');
    }

    /**
     * @param $role
     * @return mixed
     */
    public function hasRole($role): mixed
    {
        return $this->roles()->where('name', $role)->first();
    }

    /**
     * @param Builder $query
     * @return void
     */
    public function scopeFilter(Builder $query): void
    {
        $query->when(request('search'), function (Builder $q) {
            $q->where('name', 'LIKE', '%' . request('search') . '%')
                ->orWhere('email', 'LIKE', '%' . request('search') . '%');
        });

    }

    /**
     * @param Builder $query
     * @throws ContainerExceptionInterface
     * @throws NotFoundExceptionInterface
     */
    public function scopeOrder(Builder $query): void
    {
        request()->whenFilled('order_type', function () {
            Session::put("{$this->table}.order_type", request('order_type'));
        });

        request()->whenFilled('order_by', function () {
            Session::put("{$this->table}.order_by", request('order_by'));
        });

        if (request()->filled('limit') && Session::get("{$this->table}.limit") != request()->get('limit')) {
            Session::put("{$this->table}.limit", request('limit'));
        }

        $query->orderBy(
            Session::get("{$this->table}.order_by") ?? 'id',
            Session::get("{$this->table}.order_type") ?? 'DESC'
        );
    }
}

app/Http/Controllers/Admin/UserController.php
<?php

namespace App\Http\Controllers\Admin;

use App\Http\Controllers\Controller;
use App\Models\Role;
use App\Models\User;
use Illuminate\Auth\Access\AuthorizationException;
use Illuminate\Contracts\Foundation\Application;
use Illuminate\Contracts\View\Factory;
use Illuminate\Contracts\View\View;
use Illuminate\Http\JsonResponse;
use Illuminate\Http\RedirectResponse;
use Illuminate\Http\Request;
use Illuminate\Http\Response;
use Illuminate\Support\Facades\Session;

class UserController extends Controller
{
    /**
     * @param Request $request
     * @return Application|Factory|View|JsonResponse
     */
    public function index(Request $request): View|Factory|JsonResponse|Application
    {
        $table = User::query()->getQuery()->from;

        $users = User::filter()
            ->order()
            ->paginate(Session::get("{$table}.limit") ?? 8)
            ->withQueryString();

        $roles = Role::all();

        Session::put("{$table}.url", $request->fullUrl());

        if ($request->ajax()) {
            return response()->json(
                [
                    'table' => view('admin.users.table', [
                        'users' => $users,
                        'roles' => $roles,
                        'table' => $table
                    ])->render(),
                    'url' => $request->fullUrl()
                ],
                200
            );
        }

        return view('admin.users.index', [
            'users' => $users,
            'roles' => $roles,
            'table' => $table
        ]);
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return Response
     */
    public function create()
    {
        //
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param Request $request
     * @return Response
     */
    public function store(Request $request)
    {
        //
    }

    /**
     * Display the specified resource.
     *
     * @param User $user
     * @return Response
     */
    public function show(User $user)
    {
        //
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param User $user
     * @return Response
     */
    public function edit(User $user)
    {
        //
    }

    /**
     * Update the specified resource in storage.
     *
     * @param Request $request
     * @param User $user
     * @return Response
     */
    public function update(Request $request, User $user)
    {
        //
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param User $user
     * @return RedirectResponse
     * @throws AuthorizationException
     */
    public function destroy(User $user): RedirectResponse
    {
        $this->authorize('delete', $user);
        $user->delete();
        return redirect()->back()->with('success', 'Successfully deleted');
    }
}

resources/views/admin/users/index.blade.php
@extends('layouts.admin')

@section('content')
    <form action="{{ route('admin.users.index') }}" id="search" method="get" data-table="users"></form>

    <div class="card">
        <div class="card-header">
            Users
        </div>
        <div class="card-body">
            <div class="d-flex justify-content-between mb-3">
                <div>
                    <select name="limit" form="search" id="limit" style="width: 100px;" class="form-select"
                            aria-label="Default select example">
                        <option @if(Session::get('users.limit') == 8 ) selected @endif value="8">8</option>
                        <option @if(Session::get('users.limit') == 16 ) selected @endif value="16">16</option>
                        <option @if(Session::get('users.limit') == 32 ) selected @endif value="32">32</option>
                    </select>
                </div>
                <div>
                    <div class="input-group">
                        <input form="search" value="{{ request()->get('search') }}" type="text" class="form-control"
                               name="search" placeholder="Search">
                        <button data-name="search" class="btn btn-outline-danger clean-input">
                            <i class="fa-solid fa-xmark"></i>
                        </button>
                    </div>
                </div>
            </div>

            @include('admin.users.table', ['users' => $users])

        </div>
    </div>
@endsection

resources/views/admin/users/table.blade.php
<div id="{{ $table }}-table">
    <table class="table table-bordered table-hover">
        <thead>
        <tr>
            <th scope="col" class="w-25">
                <div style="display: flex; justify-content: space-between;">
                    <div>
                        Name
                    </div>
                    <div>
                        @if(Session::get("{$table }.order_by") == 'name')
                            <button data-order-by="{{ Session::get('users.order_type') }}" data-name="name"
                                    class="btn border-0 btn-sm btn-outline-secondary sort">
                                <i @if(Session::get("{$table }.order_by") == 'ASC') style="color: black"
                                   @endif class="fa-solid fa-down-long down"></i>
                                <i @if(Session::get("{$table }.order_by") == 'DESC') style="color: black"
                                   @endif class="fa-solid fa-up-long up"></i>
                            </button>
                        @else
                            <button data-order-by="" data-name="name"
                                    class="btn border-0 btn-sm btn-outline-secondary sort">
                                <i class="fa-solid fa-down-long down"></i>
                                <i class="fa-solid fa-up-long up"></i>
                            </button>
                        @endif
                    </div>
                </div>
            </th>
            <th scope="col" class="w-25">
                <div style="display: flex; justify-content: space-between;">
                    <div>
                        Email
                    </div>
                    <div>
                        @if(Session::get("{$table }.order_type") == 'email')
                            <button data-order-by="{{ Session::get('users.order_type') }}" data-name="email"
                                    class="btn border-0 btn-sm btn-outline-secondary sort">
                                <i @if(Session::get("{$table }.order_type") == 'ASC') style="color: black"
                                   @endif class="fa-solid fa-down-long down"></i>
                                <i @if(Session::get("{$table }.order_type") == 'DESC') style="color: black"
                                   @endif class="fa-solid fa-up-long up"></i>
                            </button>
                        @else
                            <button data-order-by="" data-name="email"
                                    class="btn border-0 btn-sm btn-outline-secondary sort">
                                <i class="fa-solid fa-down-long down"></i>
                                <i class="fa-solid fa-up-long up"></i>
                            </button>
                        @endif
                    </div>
                </div>
            </th>
            <th scope="col">Picture</th>
            <th scope="col"></th>
        </tr>
        </thead>
        <tbody class="table-group-divider">
        @foreach($users as $user)
            <tr>
                <td>{{ $user->name }}</td>
                <td>{{ $user->email }}</td>
                <td>
                    @isset($user->picture)
                        <img src="{{ asset('/storage/' . $user->picture) }}" style="width: 50px; height: 50px" alt="">
                    @else
                        1232
                    @endisset
                </td>

                <td>
                    <div class="d-flex justify-content-end">
                        <div>
                            @can('delete', $user)
                                <form action="{{ route('admin.users.destroy', ['user' => $user]) }}" method="post">
                                    @csrf
                                    @method('delete')
                                    <button type="submit" class="btn btn-danger">
                                        <svg xmlns="http://www.w3.org/2000/svg" width="16" height="16"
                                             fill="currentColor"
                                             class="bi bi-trash3" viewBox="0 0 16 16">
                                            <path
                                                d="M6.5 1h3a.5.5 0 0 1 .5.5v1H6v-1a.5.5 0 0 1 .5-.5ZM11 2.5v-1A1.5 1.5 0 0 0 9.5 0h-3A1.5 1.5 0 0 0 5 1.5v1H2.506a.58.58 0 0 0-.01 0H1.5a.5.5 0 0 0 0 1h.538l.853 10.66A2 2 0 0 0 4.885 16h6.23a2 2 0 0 0 1.994-1.84l.853-10.66h.538a.5.5 0 0 0 0-1h-.995a.59.59 0 0 0-.01 0H11Zm1.958 1-.846 10.58a1 1 0 0 1-.997.92h-6.23a1 1 0 0 1-.997-.92L3.042 3.5h9.916Zm-7.487 1a.5.5 0 0 1 .528.47l.5 8.5a.5.5 0 0 1-.998.06L5 5.03a.5.5 0 0 1 .47-.53Zm5.058 0a.5.5 0 0 1 .47.53l-.5 8.5a.5.5 0 1 1-.998-.06l.5-8.5a.5.5 0 0 1 .528-.47ZM8 4.5a.5.5 0 0 1 .5.5v8.5a.5.5 0 0 1-1 0V5a.5.5 0 0 1 .5-.5Z"/>
                                        </svg>
                                    </button>
                                </form>
                            @endcan
                        </div>

                        <div class="mx-2">
                            <a href="{{ route('admin.users.edit', ['user' => $user]) }}" type="button"
                               class="btn btn-warning">
                                <i class="fa-solid fa-pen"></i>
                            </a>
                        </div>
                        <div>

                            <a type="button" class="btn btn-success">
                                <svg xmlns="http://www.w3.org/2000/svg" width="16" height="16" fill="currentColor"
                                     class="bi bi-eye" viewBox="0 0 16 16">
                                    <path
                                        d="M16 8s-3-5.5-8-5.5S0 8 0 8s3 5.5 8 5.5S16 8 16 8zM1.173 8a13.133 13.133 0 0 1 1.66-2.043C4.12 4.668 5.88 3.5 8 3.5c2.12 0 3.879 1.168 5.168 2.457A13.133 13.133 0 0 1 14.828 8c-.058.087-.122.183-.195.288-.335.48-.83 1.12-1.465 1.755C11.879 11.332 10.119 12.5 8 12.5c-2.12 0-3.879-1.168-5.168-2.457A13.134 13.134 0 0 1 1.172 8z"/>
                                    <path
                                        d="M8 5.5a2.5 2.5 0 1 0 0 5 2.5 2.5 0 0 0 0-5zM4.5 8a3.5 3.5 0 1 1 7 0 3.5 3.5 0 0 1-7 0z"/>
                                </svg>
                            </a>
                        </div>

                    </div>
                </td>
            </tr>
        @endforeach
        </tbody>
    </table>
    <div class="pt-5">
        {{ $users->links() }}
    </div>
</div>